#property copyright "http://www.forex-tsd.com"
#property link      "http://www.metaquotes.ru/"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1  clrDeepSkyBlue
#property indicator_color2  clrSandyBrown
#property indicator_color3  clrSilver
#property indicator_color4  clrDarkGray
#property indicator_style1  STYLE_DOT
#property indicator_style2  STYLE_DOT
#property indicator_style3  STYLE_DOT
#property indicator_width4  2
#property strict

extern int    fastperiod   = 7;    // fast ultimate oscillator period
extern int    middleperiod = 14;   // middle ultimate oscillator period
extern int    slowperiod   = 28;   // slow ultimate oscillator period 
extern double fastK        = 4;    // Fast weight
extern double middleK      = 2;    // Middle weight
extern double slowK        = 1;    // Slow weight
extern double smoothPeriod = 5;    // Smoothing period
extern int    minmaxPeriod = 50;   // Period for floatng levels
extern double levelUp      = 0.95; // High floating level
extern double levelDn      = 0.05; // Low floating level
//---- buffers
double UOBuffer[];
double BPBuffer[];
double upLevel[];
double dnLevel[];
double miLevel[];
double divider;

//------------------------------------------------------------------
//
//------------------------------------------------------------------

int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0, upLevel);
   SetIndexBuffer(1, dnLevel);
   SetIndexBuffer(2, miLevel);
   SetIndexBuffer(3, UOBuffer);
   SetIndexBuffer(4, BPBuffer);
   IndicatorShortName("UOS(" + (string)fastperiod + ", " + (string)middleperiod + ", " + (string)slowperiod + ")");
   divider = fastK + middleK + slowK;
   return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
int start()
{
   int i,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-MathMax(MathMax(fastperiod,middleperiod),slowperiod)); 

   for(i = limit; i >= 0; i--) BPBuffer[i] = Close[i] - MathMin(Low[i], Close[i+1]);
   for(i = limit; i >= 0; i--)
   {
       double RawUO = fastK   * iMAOnArray(BPBuffer, 0, fastperiod  , 0, MODE_SMA, i) / iATR(NULL, 0, fastperiod  , i) +
                      middleK * iMAOnArray(BPBuffer, 0, middleperiod, 0, MODE_SMA, i) / iATR(NULL, 0, middleperiod, i) +
                      slowK   * iMAOnArray(BPBuffer, 0, slowperiod  , 0, MODE_SMA, i) / iATR(NULL, 0, slowperiod  , i);
       UOBuffer[i]=iSsm(RawUO/divider*100,smoothPeriod,i,0);
       double min = UOBuffer[ArrayMinimum(UOBuffer,minmaxPeriod,i)];
       double max = UOBuffer[ArrayMaximum(UOBuffer,minmaxPeriod,i)];
          upLevel[i] = min+(max-min)*levelUp;
          dnLevel[i] = min+(max-min)*levelDn;
          miLevel[i] = min+(max-min)*0.5;
   }     
   return(0);
}
  
//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

#define Pi 3.14159265358979323846264338327950288

double workSsm[][6];
#define _tprice  0
#define _ssm     1

double workSsmCoeffs[][4];
#define _speriod 0
#define _sc1    1
#define _sc2    2
#define _sc3    3

double iSsm(double price, double period, int i, int instanceNo=0)
{
   if (period<=1) return(price);
   if (ArrayRange(workSsm,0) !=Bars)                 ArrayResize(workSsm,Bars);
   if (ArrayRange(workSsmCoeffs,0) < (instanceNo+1)) ArrayResize(workSsmCoeffs,instanceNo+1);
   if (workSsmCoeffs[instanceNo][_speriod] != period)
   {
      workSsmCoeffs[instanceNo][_speriod] = period;
      double a1 = MathExp(-1.414*Pi/period);
      double b1 = 2.0*a1*MathCos(1.414*Pi/period);
         workSsmCoeffs[instanceNo][_sc2] = b1;
         workSsmCoeffs[instanceNo][_sc3] = -a1*a1;
         workSsmCoeffs[instanceNo][_sc1] = 1.0 - workSsmCoeffs[instanceNo][_sc2] - workSsmCoeffs[instanceNo][_sc3];
   }
   i = Bars-i-1;

   //
   //
   //
   //
   //

      int s = instanceNo*2; 
      workSsm[i][s+_ssm]    = price;
      workSsm[i][s+_tprice] = price;
      if (i>1)
      {  
          workSsm[i][s+_ssm] = workSsmCoeffs[instanceNo][_sc1]*(workSsm[i][s+_tprice]+workSsm[i-1][s+_tprice])/2.0 + 
                               workSsmCoeffs[instanceNo][_sc2]*workSsm[i-1][s+_ssm]                                + 
                               workSsmCoeffs[instanceNo][_sc3]*workSsm[i-2][s+_ssm]; }
   return(workSsm[i][s+_ssm]);
}